
#include <FL/fl_draw.H>
#include "magickWidget.h"
#include "magickImage.h"

MagickWidget::MagickWidget(int x, int y, int w, int h, char const *label)
	: Fl_Widget(x, y, w, h, label)
	, image(0)
{
}

MagickWidget::~MagickWidget()
{
}

void MagickWidget::draw()
{
	fl_rectf(x(), y(), w(), h());
	fl_draw_box( FL_BORDER_FRAME
				, x(), y(), w(), h()
				, FL_DARK_BLUE
			);

	if(image)
	{
		fl_draw_image(image->getPixels()
					  , x(), y()
					  , image->width(), image->height()
					  , 4
				);
	}
}

void MagickWidget::setImage(MagickImage *im)
{
	if(image)	{	delete image;	image = 0;	}

	if(im)
	{
		image = im->copy();

		// resize keeping aspect ratio.
		if(image->width() > image->height())
		{
			int nh = image->height()*w()/image->width();

			image->resize(w(), nh);
		}
		else
		{
			int nw = image->width()*h()/image->height();

			image->resize(nw, h());
		}
	}
}
