
#ifndef __RECORDS__H_
#define __RECORDS__H_

#include <string>
#include <map>

#define GL_GLEXT_PROTOTYPES
#include <GL/glu.h>
#include <GL/gl.h>

using std::string;

class ShaderRecord
{
public:
	string filename;
	GLuint number;
};

class UniformRecord
{
public:
	string name;
	GLenum type;
	GLint  size;
	string *value;
};

class LightRecord
{
public:
	int index;
	GLenum glIndex;
	GLfloat	pos[4];
	GLfloat	amb[4];
	GLfloat	dif[4];
	GLfloat spec[4];
	GLfloat spotDir[3];
	GLfloat spotExp;
	GLfloat spotCutoff;
	GLfloat attenC;
	GLfloat attenL;
	GLfloat attenQ;
	bool	enabled;
	bool	shown;
};

class MagickImage;

class TextureRecord
{
public:
	MagickImage *im;

	int 	index;
	GLenum 	glIndex;
	GLuint	texName;
	GLenum	minFilter;
	GLenum	magFilter;
	GLenum	texMode;
	GLenum	internalFormat;
	GLenum	wrapS;
	GLenum	wrapT;
	GLfloat	blendColor[4];
	GLfloat borderColor[4];
	bool	enabled;
};

typedef std::map<GLenum, string>	Type2NameMap;


#endif //__RECORDS__H_

